/*
 * This code was generated by OpenJava System.
 */
package examples.enum;


import openjava.ptree.*;
import java.util.Vector;


/**
 * The EnumMacroProcessor class is a metaclass which enables the
 * function of 'enum' on OpenJava.
 *
 * @see openjava.Class
 */
public class EnumMacroProcessor extends openjava.Class
{

  /** new modifier */
  private static final String ENUM = "enum";

  /** new keyword */
  private static final String APPLY = "apply";

  /**
   * Overrides to define a new keyword
   */
  public String[] getUserModifiers()
  {
    String[] ret = { ENUM };
    return ret;
  }

  /**
   * Overrides to detect enum declarations.
   */
  protected MemberDeclarationList translateMemberDeclarationList( MemberDeclarationList members )
  throws PtreeException
  {
    MemberDeclarationList ret = new MemberDeclarationList();
    for( int i = 0, len = members.getLength(); i < len; i++ ){
      MemberDeclaration mem = members.elementAt( i );
      if(!(mem instanceof FieldDeclaration)){
        continue;
      }
      FieldDeclaration field = (FieldDeclaration) mem;
      if(!field.getModifiers().contains( ENUM )){
        continue;
      }
      ret.append( this.makeConstantFields( field ) );
      members.removeElementAt( i );
      i--;
      len--;
    }
    for( int i = 0; i < members.getLength(); i++ ){
      ret.addElement( members.elementAt( i ) );
    }
    return super.translateMemberDeclarationList( ret );
  }

  /**
   * Adds new constant variable's declarations to the field declaration
   * list.
   * The fields are made from the constant variable's names in the
   * specified field variable declaration
   *
   * { THIS, IS, A, TEST } ->
   * { "public static final int THIS = 0;",
   *   "public static final int IS = 0;",
   *   ... }
   */
  private MemberDeclarationList makeConstantFields( FieldDeclaration fdecl )
  {
    if(!fdecl.getVariable().equals( "apply" )){
      errorMessage( "enum error : " + fdecl.getInitializer() + " must be \"apply\"." );
    }
    VariableInitializer vinit = fdecl.getInitializer();
    if(!(vinit instanceof ArrayInitializer)){
      errorMessage( "enum error : bad initializer format." );
    }
    ArrayInitializer arrayinit = (ArrayInitializer) vinit;
    MemberDeclarationList ret = new MemberDeclarationList();
    for( int i = 0; i < arrayinit.getLength(); i++ ){
      ret.addElement( FieldDeclaration.make( "public static final int " + arrayinit.elementAt( i ).toString() + " = " + i + ";" ) );
    }
    return ret;
  }

}


