/*
 * This code was generated by OpenJava System.
 */
package examples.template;


import java.lang.String;
import java.util.StringTokenizer;
import openjava.ptree.*;
import java.lang.reflect.*;


/**
 * The ListTemplate class is to be a template of wrapped list classes.
 *
 * @see examples.template.ListTemplate
 */
public class Template extends openjava.Class
{

  private static final String MASTER = "master";

  private static final String WITH = "with";

  private static final String IMITATES = "imitates";

  /**
   * The keyword of the Template class.
   */
  public String[] getUserKeywords()
  {
    String[] ret = { WITH, IMITATES };
    return ret;
  }

  /**
   * the name of the field variable of template-master class
   * This is to be used by the template-slave class.
   * This constant variable will have the string made from
   * the Identifier object, template parameter.
   */
  public static final String PARAM_VAR = "_templateParamName";

  /**
   * the name of the field variable of template-master class
   * This is to be used by the template-slave class.
   * This constant variable will have the string made from
   * the MemberDeclarationList object.
   */
  public static final String MEMBER_ATTR_VAR = "_templateFieldAttr";

  /** template-master class of this template-slave class */
  private Class masterClass = null;

  /** virtual type name of template parameter of template-master class */
  private String paramTypeName = null;

  /** virtual type name of template parameter of template-slave class */
  private String virtualTypeName = null;

  /** active type name of template parameter of template-slave class */
  private String activeTypeName = null;

  /**
   * At first, this detects if this is a template-master and
   * if this is a template-slave.
   *
   */
  protected TypeDeclaration translateClassDeclaration( ClassDeclaration classdecl )
  throws PtreeException
  {
    try{
      UserDecoratorList udlist = classdecl.getUserDecorators();
      MemberDeclarationList members = classdecl.getBody();
      for( int i = 0; i < udlist.getLength(); i++ ){
        UserDecorator ud = udlist.elementAt( i );
        AnyWordList words = ud.getWords();
        if(ud.getKeyword().equals( WITH )){
          System.err.println( "Template : this is a master of template." );
          if(words.getLength() != 1){
            throw new Exception( "syntax error in with" );
          }
          this.paramTypeName = words.elementAt( 0 ).toString();
          members.addElement( FieldDeclaration.make( "public static String " + MEMBER_ATTR_VAR + " = \"" + members.toFlattenString() + "\";" ) );
          members.addElement( FieldDeclaration.make( "public static String " + PARAM_VAR + " = \"" + this.paramTypeName + "\";" ) );
        }else{
          if(ud.getKeyword().equals( IMITATES )){
            System.err.println( "Template : this is a slave of template." );
            if(words.getLength() != 4){
              throw new Exception( "Template : syntax error." );
            }
            this.masterClass = forName( words.elementAt( 0 ).toString() );
            this.activeTypeName = words.elementAt( 2 ).toString();
            Field pvfld = this.masterClass.getField( PARAM_VAR );
            this.virtualTypeName = (String) pvfld.get( null );
            Field templatefld = this.masterClass.getField( MEMBER_ATTR_VAR );
            String memstr = (String) templatefld.get( null );
            members.append( makeMemberDeclarationList( memstr ) );
          }
        }
      }
    }catch( Exception ex ){
      errorMessage( "Template : something error : " + ex );
    }
    return super.translateClassDeclaration( classdecl );
  }

  /**
   * Replace virtual type names with active type names
   * for template-slave class.
   *
   * If you want to compare Leaf object with String object,
   * you should use the equals method of Leaf.
   *
   */
  protected ClassType translateClassType( ClassType ctype )
  throws PtreeException
  {
    Identifier name = ctype.getName();
    if(this.masterClass != null && name.equals( this.virtualTypeName )){
      System.err.println( ctype + " -> " + this.activeTypeName );
      ctype.setName( new Identifier( this.activeTypeName ) );
      return super.translateClassType( ctype );
    }
    if(name.equals( this.paramTypeName )){
      ctype.setName( new Identifier( "Object" ) );
    }
    return super.translateClassType( ctype );
  }

  /**
   * Set constructor's names for template-slave class.
   */
  protected MemberDeclaration translateConstructorDeclaration( ConstructorDeclaration constrdecl )
  throws PtreeException
  {
    if(this.masterClass != null){
      TypeDeclaration td = getTypeDeclaration();
      constrdecl.setName( td.getName() );
    }
    return super.translateConstructorDeclaration( constrdecl );
  }

}


