/*
 * CaseLabelList.java 1.0
 *  
 * @see openjava.ptree.Ptree
 * @version last updated: 06/11/97
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.tools.*;


/**
 * The CaseLabelList class presents for the node of parse tree
 * of CaseLabel
 *
 */
public class CaseLabelList extends List
{
  public CaseLabelList() {
    super( "" );
  }

  public CaseLabelList( CaseLabel e0 )
  {
    super( "", e0 );
  }

  public CaseLabelList( CaseLabel e0, CaseLabel e1 )
  {
    super( "", e0, e1 );
  }

  public void writeCode()
  {
    if(getLength() == 0)  return;

    for( int i = 0; i < getLength(); i++ ){
      elementAt( i ).writeCode();
      out.println();
    }
  }

  /**
   * Gets the specified element at
   * This causes side-effect.
   *
   * @param  n  
   */
  public CaseLabel elementAt( int n )
  {
    return (CaseLabel) ptreelist.elementAt( n );
  }

  /**
   * Sets the specified element at the specified place of the list
   *
   * @param  p  element
   * @param  n  the number where to set element
   */
  public void setElementAt( CaseLabel p, int n )
  {
    ptreelist.setElementAt( (Ptree) p, n );
  }

  /**
   * Adds the specified element after the list
   * This causes side-effect.
   *
   * @param  p  CaseLabel to be inserted into the list
   */
  public void addElement( CaseLabel p )
  {
    ptreelist.addElement( (Ptree) p );
  }

  /**
   * Inserts the specified element into the list
   * before the specified element of the list.
   * This causes side-effect.
   *
   * @param  p  the element to be inserted into the list
   * @param  n  number of the element before which insertion ocuurs
   */
  public void insertElementAt( CaseLabel p, int n )
  {
    ptreelist.insertElementAt( (Ptree) p, n );
  }

  /**
   * Returns the first element
   *
   * @returns  the first element
   */
  public CaseLabel getFirst()
  {
    return (CaseLabel) ptreelist.getFirst();
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   *
   * @returns the rest list except for the first element
   */
  public CaseLabelList getRest()
  {
    CaseLabelList ret = new CaseLabelList();
    for( int i = 1; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }


  /**
   * Appends a list after this list.
   *
   * @param  lst  a list to be appended
   */
  public void append( CaseLabelList lst )
  {
    for( int i = 0; i < lst.getLength(); i++ ){
      ptreelist.addElement( lst.elementAt( i ) );
    }
  }


}
