/*
 * ClassTypeList.java 1.0
 *  
 * @see openjava.ptree.Ptree
 * @version last updated: 06/11/97
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.tools.*;


/**
 * The ClassTypeList class presents for the node of parse tree
 * of qualified name.
 *
 */
public class ClassTypeList extends List
{
  public ClassTypeList() {
    super( ", " );
  }

  public ClassTypeList( ClassType e0 )
  {
    super( ", ", e0 );
  }

  public ClassTypeList( ClassType e0, ClassType e1 )
  {
    super( ", ", e0, e1 );
  }

  public void writeCode()
  {
    writeDebugL();

    super.writeCode();

    writeDebugR();
  }

  /**
   * Gets the specified element at
   * This causes side-effect.
   *
   * @param  n  
   */
  public ClassType elementAt( int n )
  {
    return (ClassType) ptreelist.elementAt( n );
  }

  /**
   * Sets the specified element at the specified place of the list
   *
   * @param  p  element
   * @param  n  the number where to set element
   */
  public void setElementAt( ClassType p, int n )
  {
    ptreelist.setElementAt( (Ptree) p, n );
  }

  /**
   * Adds the specified element after the list
   * This causes side-effect.
   *
   * @param  p  ClassType to be inserted into the list
   */
  public void addElement( ClassType p )
  {
    ptreelist.addElement( (Ptree) p );
  }

  /**
   * Inserts the specified element into the list
   * before the specified element of the list.
   * This causes side-effect.
   *
   * @param  p  the element to be inserted into the list
   * @param  n  number of the element before which insertion ocuurs
   */
  public void insertElementAt( ClassType p, int n )
  {
    ptreelist.insertElementAt( (Ptree) p, n );
  }

  /**
   * Returns the first element
   *
   * @returns  the first element
   */
  public ClassType getFirst()
  {
    return (ClassType) ptreelist.getFirst();
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   *
   * @returns the rest list except for the first element
   */
  public ClassTypeList getRest()
  {
    ClassTypeList ret = new ClassTypeList();
    for( int i = 1; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }


  /**
   * Appends a list after this list.
   *
   * @param  lst  a list to be appended
   */
  public void append( ClassTypeList lst )
  {
    for( int i = 0; i < lst.getLength(); i++ ){
      ptreelist.addElement( (Ptree) lst.elementAt( i ) );
    }
  }


}
