/*
 * Expression.java 1.0
 *
 *
 * Jun 20, 1997
 * Sep 29, 1997
 *
 * @see openjava.ptree.Ptree
 * @version 1.0 last updated:  Sep 29, 1997
 * @author  Teruo -bv- Koyanagi
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.main.SymbolTable;


/**
 * The Expression interface presents common interface
 * to access Expression node of parse tree
 *
 * this interface is implements by
 *   UnaryExpression
 *   BinaryExpression
 *   ConditionalExpression
 *   AssignmentExpression
 *   CastExpression
 *   AllocationExpression
 *     ConstructExpression
 *     ArrayAllocationExpression
 *     AnonymousAllocationExpression
 *   QualifiedName
 *   MethodCall
 *   SpecialName
 *   Literal
 *   ArrayAccess
 *   FieldAccess
 *
 * @see openjava.ptree.Ptree
 * @see openjava.ptree.NonLeaf
 * @see openjava.ptree.VariableInitializer
 */
public interface Expression extends Ptree, VariableInitializer
{
}
