/*
 * ExpressionStatement.java 1.0
 *
 * Jun 20, 1997 mich
 * Sep 29, 1997 bv
 * Oct 11, 1997 mich
 *
 * @see openjava.ptree.Ptree
 * @version 1.0 last updated:  Oct 11, 1997
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.main.SymbolTable;


/**
 * The ExpressionStatement class presents expression statement node
 * of parse tree
 *
 * @see openjava.ptree.Ptree
 * @see openjava.ptree.NonLeaf
 * @see openjava.ptree.Statement
 * @see openjava.ptree.Expression
 */
public class ExpressionStatement extends NonLeaf
    implements Statement
{
  /**
   * Allocates a new object.
   *
   * @param statement prototype object
   */
  public ExpressionStatement( Expression expr )
  {
    super();
    set( (Ptree) expr );
  }

  ExpressionStatement()
  {
    super();
  }
  
  public void writeCode()
  {
    writeTab();  writeDebugL();

    Expression expr = getExpression();
    expr.writeCode();

    out.print(";");

    writeDebugR();  out.println();
  }

  /**
   * Gets the expression of this statement.
   *
   * @return  the expression.
   */
  public Expression getExpression()
  {
    return (Expression) elementAt( 0 );
  }

  /**
   * Sets the expression of this statement.
   *
   * @param  the expression to set.
   */
  public void setExpression( Expression expr )
  {
    setElementAt( expr, 0 );
  }

}
