/*
 * MemberDeclarationList.java 1.0
 *  
 * @see openjava.ptree.Ptree
 * @version last updated: 06/11/97
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.tools.*;


/**
 * The MemberDeclarationList class presents for the node of parse tree
 * of MemberDeclaration
 *
 */
public class MemberDeclarationList extends List
{
  public MemberDeclarationList() {
    super( PtreeObject.LN );
  }

  public MemberDeclarationList( MemberDeclaration e0 )
  {
    super( PtreeObject.LN, (Ptree) e0 );
  }

  public MemberDeclarationList( MemberDeclaration e0, MemberDeclaration e1 )
  {
    super( PtreeObject.LN, (Ptree) e0, (Ptree) e1 );
  }

  public void writeCode()
  {
    super.writeCode();
  }

  /**
   * Gets the specified element at
   * This causes side-effect.
   *
   * @param  n  
   */
  public MemberDeclaration elementAt( int n )
  {
    return (MemberDeclaration) ptreelist.elementAt( n );
  }

  /**
   * Sets the specified element at the specified place of the list
   *
   * @param  p  element
   * @param  n  the number where to set element
   */
  public void setElementAt( MemberDeclaration p, int n )
  {
    ptreelist.setElementAt( (Ptree) p, n );
  }

  /**
   * Adds the specified element after the list
   * This causes side-effect.
   *
   * @param  p  MemberDeclaration to be inserted into the list
   */
  public void addElement( MemberDeclaration p )
  {
    ptreelist.addElement( (Ptree) p );
  }

  /**
   * Inserts the specified element into the list
   * before the specified element of the list.
   * This causes side-effect.
   *
   * @param  p  the element to be inserted into the list
   * @param  n  number of the element before which insertion ocuurs
   */
  public void insertElementAt( MemberDeclaration p, int n )
  {
    ptreelist.insertElementAt( (Ptree) p, n );
  }

  /**
   * Returns the first element
   *
   * @returns  the first element
   */
  public MemberDeclaration getFirst()
  {
    return (MemberDeclaration) ptreelist.getFirst();
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   *
   * @returns the rest list except for the first element
   */
  public MemberDeclarationList getRest()
  {
    MemberDeclarationList ret = new MemberDeclarationList();
    for( int i = 1; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }


  /**
   * Appends a list after this list.
   *
   * @param  lst  a list to be appended
   */
  public void append( MemberDeclarationList lst )
  {
    for( int i = 0; i < lst.getLength(); i++ ){
      ptreelist.addElement( lst.elementAt( i ) );
    }
  }


}
