/*
 * Modifier.java 1.0
 *
 *
 * Jun 20, 1997 by mich
 * Sep 29, 1997 by bv
 * Oct 11, 1997 by mich
 *
 * @see openjava.ptree.Ptree
 * @version 1.0 last updated:  Oct 11, 1997
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.main.SymbolTable;


/**
 * The <code>Modifier</code> class represents
 * a modifier node of parse tree.
 * 
 * @see openjava.ptree.Ptree
 * @see openjava.ptree.Leaf
 */
public class Modifier extends Leaf
{
  public static final int ABSTRACT = 0;
  public static final int FINAL = 1;
  public static final int PUBLIC = 2;
  public static final int PROTECTED = 3;
  public static final int PRIVATE = 4;
  public static final int STATIC = 5;
  public static final int TRANSIENT = 6;
  public static final int VOLATILE = 7;
  public static final int NATIVE = 8;
  public static final int SYNCHRONIZED = 9;
  public static final int USERMODIFIER = 20;
  
  final static String modifier_name[] = {
    "abstract", "final", "public", "protected", 
    "private", "static", "transient", "volatile",
    "native", "synchronized"
    };
  
  private int id = -1;
  
  public Modifier( int id )
  {
    super( modifier_name[id] );
    this.id = id;
  }
  
  public Modifier( String str )
  {
    super( str );
    this.id = Modifier.USERMODIFIER;
  }

  public int getKind()
  {
    return this.id;
  }

  public void writeCode()
  {
    if(getDebugFlag()){
      super.writeCode();
    }else if(this.id != Modifier.USERMODIFIER){
      super.writeCode();
    }
  }

}
