/*
 * ModifierList.java 1.0
 *  
 * @see openjava.ptree.Ptree
 * @version last updated: 06/11/97
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.tools.*;


/**
 * The ModifierList class presents for the node of parse tree
 * of qualified name.
 *
 */
public class ModifierList extends List
{
  public ModifierList() {
    super( " " );
  }

  public ModifierList( Modifier e0 )
  {
    super( " ", e0 );
  }

  public ModifierList( Modifier e0, Modifier e1 )
  {
    super( " ", e0, e1 );
  }

  public void writeCode()
  {
    writeDebugL();

    super.writeCode();

    writeDebugR();
  }

  /**
   * Gets the specified element at
   * This causes side-effect.
   *
   * @param  n  
   */
  public Modifier elementAt( int n )
  {
    return (Modifier) ptreelist.elementAt( n );
  }

  /**
   * Sets the specified element at the specified place of the list
   *
   * @param  p  element
   * @param  n  the number where to set element
   */
  public void setElementAt( Modifier p, int n )
  {
    ptreelist.setElementAt( p, n );
  }

  /**
   * Adds the specified element after the list
   * This causes side-effect.
   *
   * @param  p  Modifier to be inserted into the list
   */
  public void addElement( Modifier p )
  {
    ptreelist.addElement( p );
  }

  /**
   * Inserts the specified element into the list
   * before the specified element of the list.
   * This causes side-effect.
   *
   * @param  p  the element to be inserted into the list
   * @param  n  number of the element before which insertion ocuurs
   */
  public void insertElementAt( Modifier p, int n )
  {
    ptreelist.insertElementAt( p, n );
  }

  /**
   * Returns the first element
   *
   * @returns  the first element
   */
  public Modifier getFirst()
  {
    return (Modifier) ptreelist.getFirst();
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   *
   * @returns the rest list except for the first element
   */
  public ModifierList getRest()
  {
    ModifierList ret = new ModifierList();
    for( int i = 1; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }


  /**
   * Appends a list after this list.
   *
   * @param  lst  a list to be appended
   */
  public void append( ModifierList lst )
  {
    for( int i = 0; i < lst.getLength(); i++ ){
      ptreelist.addElement( lst.elementAt( i ) );
    }
  }


}
