/*
 * PrimitiveType.java 1.0
 *
 *
 * Jun 20, 1997 by mich
 * Sep 29, 1997 by bv
 * Oct 12, 1997 by mich
 *
 * @see openjava.ptree.Ptree
 * @version 1.0 last updated:  Oct 12, 1997
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.main.SymbolTable;


/**
 * The PrimitiveType class presents primitive type node of parse tree.
 *
 * @see openjava.ptree.Ptree
 * @see openjava.ptree.Leaf
 */
public class PrimitiveType extends Leaf
   implements TypeName
{
    public static final int BOOLEAN = 0;
    public static final int CHAR = 1;
    public static final int BYTE = 2;
    public static final int SHORT = 3;
    public static final int INT = 4;
    public static final int LONG = 5;
    public static final int FLOAT = 6;
    public static final int DOUBLE = 7;
    public static final int VOID = 8;
  
    static final String[] primitive_name = {
	"boolean", "char", "byte", "short", "int",
	"long", "float", "double", "void"
    };
  
    int id = -1;
  
    public PrimitiveType( int id ) {
	super( primitive_name[id] );
	this.id = id;
    }
  
    public void writeCode() {
	super.writeCode();
    }

    /**
     * Obtains the id number of this primitive type.
     *
     * @return the id number
     */
    public int getType() {
	return id;
    }

    public int getKind() { return getType(); }
}
