/*
 * SpecialName.java 1.0
 *
 * Jun 20, 1997 by micn
 * Sep 29, 1997 by bv
 * Oct 10, 1997 by mich
 *
 * @see openjava.ptree.Ptree
 * @version 1.0 last updated:  Oct 10, 1997
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.main.SymbolTable;


/**
 * 
 */
public class SpecialName extends Leaf
    implements Expression
{
  public static final int NULL = 0;
  public static final int THIS = 1;
  public static final int SUPER = 2;
  
  static final String[] special_name
  = { "null", "this", "super" };
  
  int id = -1;
  
  public SpecialName( int id )
  {
    super(special_name[id]);
    this.id = id;
  }

    /**
     * Returns the id number indicating the kind of this literal.
     *
     * @return  the id number
     */
    public int getKind() {
        return this.id;
    }

    /**
     * Use getKind()
     * @deprecated
     */
    public int getID() { return getKind(); }

}
