/*
 * StatementList.java 1.0
 *  
 * @see openjava.ptree.Ptree
 * @version last updated: 06/11/97
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.tools.*;


/**
 * The StatementList class presents for the node of parse tree
 * of Statement
 *
 */
public class StatementList extends List
{
  public StatementList() {
    super( "" );
  }

  public StatementList( Statement e0 )
  {
    super( "", (Ptree) e0 );
  }

  public StatementList( Statement e0, Statement e1 )
  {
    super( "", (Ptree) e0, (Ptree) e1 );
  }

  public void writeCode()
  {
    super.writeCode();
  }

  /**
   * Gets the specified element at
   * This causes side-effect.
   *
   * @param  n  
   */
  public Statement elementAt( int n )
  {
    return (Statement) ptreelist.elementAt( n );
  }

  /**
   * Sets the specified element at the specified place of the list
   *
   * @param  p  element
   * @param  n  the number where to set element
   */
  public void setElementAt( Statement p, int n )
  {
    ptreelist.setElementAt( (Ptree) p, n );
  }

  /**
   * Adds the specified element after the list
   * This causes side-effect.
   *
   * @param  p  Statement to be inserted into the list
   */
  public void addElement( Statement p )
  {
    ptreelist.addElement( (Ptree) p );
  }

  /**
   * Inserts the specified element into the list
   * before the specified element of the list.
   * This causes side-effect.
   *
   * @param  p  the element to be inserted into the list
   * @param  n  number of the element before which insertion ocuurs
   */
  public void insertElementAt( Statement p, int n )
  {
    ptreelist.insertElementAt( (Ptree) p, n );
  }

  /**
   * Returns the first element
   *
   * @returns  the first element
   */
  public Statement getFirst()
  {
    return (Statement) ptreelist.getFirst();
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   *
   * @returns the rest list except for the first element
   */
  public StatementList getRest()
  {
    StatementList ret = new StatementList();
    for( int i = 1; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }


  /**
   * Appends a list after this list.
   *
   * @param  lst  a list to be appended
   */
  public void append( StatementList lst )
  {
    for( int i = 0; i < lst.getLength(); i++ ){
      ptreelist.addElement( lst.elementAt( i ) );
    }
  }


}
