/*
 * TypeDeclarationList.java 1.0
 *  
 * @see openjava.ptree.Ptree
 * @version last updated: 06/11/97
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.tools.*;


/**
 * The TypeDeclarationList class presents for the node of parse tree
 * of TypeDeclaration
 *
 */
public class TypeDeclarationList extends List
{
  private static final String LNLN = PtreeObject.LN + PtreeObject.LN;
  public TypeDeclarationList() {
    super( LNLN );
  }

  public TypeDeclarationList( TypeDeclaration e0 )
  {
    super( LNLN, (Ptree) e0 );
  }

  public TypeDeclarationList( TypeDeclaration e0, TypeDeclaration e1 )
  {
    super( LNLN, (Ptree) e0, (Ptree) e1 );
  }

  public void writeCode()
  {
    super.writeCode();
  }

  /**
   * Gets the specified element at
   * This causes side-effect.
   *
   * @param  n  
   */
  public TypeDeclaration elementAt( int n )
  {
    return (TypeDeclaration) ptreelist.elementAt( n );
  }

  /**
   * Sets the specified element at the specified place of the list
   *
   * @param  p  element
   * @param  n  the number where to set element
   */
  public void setElementAt( TypeDeclaration p, int n )
  {
    ptreelist.setElementAt( (Ptree) p, n );
  }

  /**
   * Adds the specified element after the list
   * This causes side-effect.
   *
   * @param  p  TypeDeclaration to be inserted into the list
   */
  public void addElement( TypeDeclaration p )
  {
    ptreelist.addElement( (Ptree) p );
  }

  /**
   * Inserts the specified element into the list
   * before the specified element of the list.
   * This causes side-effect.
   *
   * @param  p  the element to be inserted into the list
   * @param  n  number of the element before which insertion ocuurs
   */
  public void insertElementAt( TypeDeclaration p, int n )
  {
    ptreelist.insertElementAt( (Ptree) p, n );
  }

  /**
   * Returns the first element
   *
   * @returns  the first element
   */
  public TypeDeclaration getFirst()
  {
    return (TypeDeclaration) ptreelist.getFirst();
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   *
   * @returns the rest list except for the first element
   */
  public TypeDeclarationList getRest()
  {
    TypeDeclarationList ret = new TypeDeclarationList();
    for( int i = 1; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }


  /**
   * Appends a list after this list.
   *
   * @param  lst  a list to be appended
   */
  public void append( TypeDeclarationList lst )
  {
    for( int i = 0; i < lst.getLength(); i++ ){
      ptreelist.addElement( lst.elementAt( i ) );
    }
  }


}
