/*
 * UserStatement.java 1.0
 *
 * This interface is made to type ptree-node into the type
 * specifier in the body of class.
 *
 * Jun 20, 1997 by mich
 * Sep 29, 1997 by mich
 * Oct 11, 1997 by mich
 *
 * @see openjava.ptree.Ptree
 * @version 1.0 last updated:  Oct 11, 1997
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.main.SymbolTable;


/**
 * The UserDecorator class presents for user-decorator node
 * of parse tree
 *
 * @see openjava.ptree.Ptree
 * @see openjava.ptree.NonLeaf
 * @see openjava.ptree.Statement
 */
public class UserDecorator extends NonLeaf
    implements Statement
{
  public UserDecorator( UserDecorator ud )
  {
    super();
  }
  
  public UserDecorator(
    Leaf userkeyword,
    AnyWordList awlst )
  {
    super();
    set( userkeyword, awlst );
  }

  UserDecorator() {
    super();
  }

  public void writeCode()
  {
    if(getDebugFlag()){
      writeDebugL();

      Leaf uk = getKeyword();
      uk.writeCode();

      out.print( "{ " );

      AnyWordList awlist = getWords();
      awlist.writeCode();

      out.print( " }" );

      writeDebugR();
    }
  }

  public Leaf getKeyword()
  {
    return (Leaf) elementAt( 0 );
  }

  public AnyWordList getWords()
  {
    return (AnyWordList) elementAt( 1 );
  }

}
