/*
 * UserDecoratorList.java 1.0
 *  
 * Jun 11, 1997
 *
 * @see openjava.ptree.Ptree
 * @version last updated: 06/11/97
 * @author  Michiaki Tatsubori
 */
package openjava.ptree;


import java.lang.String;
import java.io.OutputStream;
import openjava.tools.*;


/**
 * The UserDecoratorList class presents for the node of parse tree
 * of qualified name.
 *
 */
public class UserDecoratorList extends List
{
  public UserDecoratorList() {
    super( " " );
  }

  public UserDecoratorList( UserDecorator e0 )
  {
    super( " ", e0 );
  }

  public UserDecoratorList( UserDecorator e0, UserDecorator e1 )
  {
    super( " ", e0, e1 );
  }

  public void writeCode()
  {
    writeDebugL();
    super.writeCode();
    writeDebugR();
  }

  /**
   * Gets the specified element at
   * This causes side-effect.
   *
   * @param  n  
   */
  public UserDecorator elementAt( int n )
  {
    return (UserDecorator) ptreelist.elementAt( n );
  }

  /**
   * Sets the specified element at the specified place of the list
   *
   * @param  p  element
   * @param  n  the number where to set element
   */
  public void setElementAt( UserDecorator p, int n )
  {
    ptreelist.setElementAt( p, n );
  }

  /**
   * Adds the specified element after the list
   *
   * @param  p  UserDecorator to be inserted into the list
   */
  public void addElement( UserDecorator p )
  {
    ptreelist.addElement( p );
  }

  /**
   * Inserts the specified element into the list
   * before the specified element of the list.
   *
   * @param  p  the element to be inserted into the list
   * @param  n  number of the element before which insertion ocuurs
   */
  public void insertElementAt( UserDecorator p, int n )
  {
    ptreelist.insertElementAt( p, n );
  }

  /**
   * Returns the first element
   *
   * @returns  the first element
   */
  public UserDecorator getFirst()
  {
    return (UserDecorator) ptreelist.getFirst();
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   * This does't cause side-effect as a list.
   *
   * @returns the rest list except for the first element
   */
  public UserDecoratorList getRest()
  {
    UserDecoratorList ret = new UserDecoratorList();
    for( int i = 1; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }

  public UserDecorator lastElement()
  {
    return (UserDecorator) ptreelist.lastElement();
  }

  /**
   * Appends a list after this list.
   * This doesn't cause side-effect as a list.
   *
   * @param  lst  a list to be appended
   */
  public void append( UserDecoratorList lst )
  {
    for( int i = 0; i < lst.getLength(); i++ ){
      ptreelist.addElement( lst.elementAt( i ) );
    }
  }

  public boolean contains( String str )
  {
    for( int i = 0; i < getLength(); i++ ){
      if(elementAt( i ).getKeyword().equals( str )){
	return true;
      }
    }
    return false;
  }

}




