/*
 * List.java 1.0
 * 
 * Jun 11, 1997 by mich
 * Aug 20, 1997 by mich
 * Sep 28, 1997 by mich
 * 
 * @see java_cup.runtime.symbol
 * @version 1.0 last updated: Sep 28, 1997
 * @author  Michiaki Tatsubori
 */
package openjava.tools;


import java.lang.String;
import java.io.PrintStream;
import java.util.Vector;
import openjava.ptree.*;


/**
 * The UtilityList class is a utitlity list
 *
 */
public class UtilityList extends Vector
{
  /**
   * Allocates this UtilityList
   *
   */
  public UtilityList()
  {
    super();
  }

  /**
   * Allocates this UtilityList
   *
   * @param p0  list's element
   */
  public UtilityList( Object p )
  {
    super( 1 );
    setList( p );
  }

  /**
   * Allocates this UtilityList with the specified ptree elements.
   *
   * @param p0  list's element
   * @param p1  list's element
   */
  public UtilityList( Object p0, Object p1 )
  {
    super( 2 );
    setList( p0, p1 );
  }

  /**
   * Allocates this UtilityList with the specified ptree elements.
   *
   * @param p0  list's element
   * @param p1  list's element
   * @param p2  list's element
   */
  public UtilityList( Object p0, Object p1, Object p2 )
  {
    super( 3 );
    setList( p0, p1, p2 );
  }

  /**
   * Allocates this UtilityList with the specified ptree elements.
   *
   * @param p0  list's element
   * @param p1  list's element
   * @param p2  list's element
   * @param p3  list's element
   */
  public UtilityList( Object p0, Object p1, Object p2, Object p3 )
  {
    super( 4 );
    setList( p0, p1, p2, p3 );
  }

  /**
   * Returns the length of this list.
   *
   * @return  the length of this list
   */
  public int getLength()
  {
    return size();
  }

  /**
   * Makes this ptree a list presenting for
   * [ p ]
   *
   * @param p list's element
   */
  public void setList( Object p )
  {
    addElement( p );
  }

  /**
   * Makes this ptree a list presenting for
   * [ p0 p1 ]
   *
   * @param p0 list's element
   * @param p1 list's element
   **/
  public void setList( Object p0, Object p1 )
  {
    addElement( p0 );
    addElement( p1 );
  }

  /**
   * Makes this ptree a list presenting for
   * [ p0 p1 p2 ]
   *
   * @param p0 list's element
   * @param p1 list's element
   * @param p2 list's element
   **/
  public void setList( Object p0, Object p1, Object p2 )
  {
    addElement( p0 );
    addElement( p1 );
    addElement( p2 );
  }

  /**
   * Makes this ptree a list presenting for
   * [ p0 p1 p2 ]
   *
   * @param p0 list's element
   * @param p1 list's element
   * @param p2 list's element
   * @param p3 list's element
   */
  public void setList( Object p0, Object p1, Object p2, Object p3 )
  {
    addElement( p0 );
    addElement( p1 );
    addElement( p2 );
    addElement( p3 );
  }

  /**
   * Makes this ptree a list presenting for
   * [ p0 p1 p2 p3 p4 ]
   * @param p0 list's element
   * @param p1 list's element
   * @param p2 list's element
   * @param p3 list's element
   * @param p4 list's element
   */
  public void setList( Object p0, Object p1, Object p2, Object p3,
		       Object p4 )
  {
    addElement( p0 );
    addElement( p1 );
    addElement( p2 );
    addElement( p3 );
    addElement( p4 );
  }

  /**
   * Makes this ptree a list presenting for
   * [ p0 p1 p2 p3 p4 p5 ]
   * @param p0 list's element
   * @param p1 list's element
   * @param p2 list's element
   * @param p3 list's element
   * @param p4 list's element
   * @param p5 list's element
   */
  public void setList( Object p0, Object p1, Object p2, Object p3,
		       Object p4, Object p5 )
  {
    addElement( p0 );
    addElement( p1 );
    addElement( p2 );
    addElement( p3 );
    addElement( p4 );
    addElement( p5 );
  }

  /**
   * Makes this ptree a list presenting for
   * [ p0 p1 p2 p3 p4 p5 p6 ]
   *
   * @param p0 list's element
   * @param p1 list's element
   * @param p2 list's element
   * @param p3 list's element
   * @param p4 list's element
   * @param p5 list's element
   * @param p6 list's element
   */
  public void setList( Object p0, Object p1, Object p2, Object p3,
		       Object p4, Object p5, Object p6 )
  {
    addElement( p0 );
    addElement( p1 );
    addElement( p2 );
    addElement( p3 );
    addElement( p4 );
    addElement( p5 );
    addElement( p6 );
  }

  /**
   * Appends a list after this list.
   *
   * @param  q  a list to be appended
   */
  public void append( UtilityList q )
  {
    for( int i = 0; i < q.getLength(); i++ ){
      addElement( q.elementAt( i ) );
    }
  }

  /**
   * Returns the first element
   *
   * @param p the list
   * @returns the first cons of the list
   */
  public Object getFirst()
  {
    return elementAt( 0 );
  }

  /**
   * Returns the new list from this list's element except for
   * the first element
   *
   * @param p the list
   * @returns the rest list except for the first cons
   */
  public UtilityList getRest()
  {
    UtilityList ret = new UtilityList();
    for( int i = 0; i < getLength(); i++ ){
      ret.addElement( elementAt( i ) );
    }

    return ret;
  }

  /**
   * NOT IMPLEMENTED
   *
   * @param p the node
   * @param k Kth
   * @returns the Kth or the tail of the list
   */
  public static UtilityList listTail( UtilityList list, int k )
  {
    return null;
  }

  /**
   * NOT IMPLEMENTED
   *
   * @param p the node
   * @returns new copylist
   */
  public UtilityList makeCopy()
  {
    return null;
  }

  /**
   * NOT IMPLEMENTED
   *
   * q may be a leaf
   * @param p the node
   * @param q the node
   * @returns new list
   */
  public static UtilityList appendList( UtilityList p, UtilityList q )
  {
    return null;
  }

  /**
   * NOT EPLEMENTED
   *  replaceAll() substitutes SUBST for all occurences of ORIG in LIST.
   *  It recursively searches LIST for ORIG.
   * @param list the list
   * @param pos the position to substitute element at
   * @param orig the original node
   * @returns new list
   */
  public static Ptree replaceAll( Ptree list, Ptree orig, Ptree subst )
  {
    return null;
  }

  /**
   * NOT IMPLEMENTED
   *  replace() makes a new list (.. new_element ..)
   *  from (.. orig_element ..).
   * @param list the list
   * @param orig_element original element
   * @param new_element new element
   * @returns new list
   */
  public static Ptree replace( Ptree list, Ptree orig_element,
			       Ptree new_element )
  {
    return null;
  }

  /**
   * NOT IMPLEMENTED
   *
   *  replace() makes a new list (.. new_element ..) from (.. orig_element ..).
   * @param list the list
   * @param orig_element original element
   * @param new_element new element
   * @returns new list
   */
  public static Ptree replaceTail( Ptree list, Ptree original, Ptree subst )
  {
    return null;
  }

  /**
   * NOT IMPLEMENTED
   *
   * @param env the environment node
   * @param expr the expression node
   * @param func the mapping function class
   * @returns new list
   */
  //public static Ptree map( Ptree expr, PtreeFunction func )
  //{
  //  return null;
  //}

}
