/*
 * Comment.java 1.0
 *
 *
 * Oct 15, 1997 by mich
 *
 * @see openjava.ptree.Ptree
 * @version 1.0 last updated:  Oct 15, 1997
 * @author  Michiaki Tatsubori
 */
package openjava.util;


import java.lang.String;
import java.lang.StringBuffer;
import java.util.Vector;
import java.util.StringTokenizer;
import openjava.ptree.Ptree;
import openjava.ptree.PtreeObject;


/**
 * The Comment class is for javadoc comment of OpenJava.
 *
 * @see openjava.ptree.PtreeObject
 */
public class Comment extends PtreeObject
{
  private Vector vec = null;

  public Comment( Vector vec )
  {
    super();
    this.vec = vec;
  }

  public void writeCode()
  {
    if(vec == null)  return;
    if(vec.isEmpty())  return;
    writeTab();
    int len = vec.size();
    for( int i = 0; i < len; i++ ){
      out.println( vec.elementAt( i ) );
    }
    return;
  }

  public Ptree makeCopy()
  {
    return new Comment( (Vector) vec.clone() );
  }

  public Ptree makeRecursiveCopy()
  {
    return new Comment( (Vector) vec.clone() );
  }

  public String toString()
  {
    return super.toString();
  }

  public boolean equals( Ptree p )
  {
    if(! (p instanceof Comment))  return false;
    return false;
  }

}
